using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserContract;
namespace CMSMicroservice.Protobuf.Validator.UserContract;

public class CreateNewUserContractRequestValidator : AbstractValidator<CreateNewUserContractRequest>
{
    public CreateNewUserContractRequestValidator()
    {
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.ContractId)
            .NotNull();
        RuleFor(model => model.SignGuid)
            .NotEmpty();
        RuleFor(model => model.SignedPdfFile)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserContractRequest>.CreateWithOptions((CreateNewUserContractRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
